# GoCV Commands

GoCV comes with various useful command line utilities, that are also examples of how to use the package.

## Caffe Classifier

Capture video from a connected webcam, then use the Caffe deep learning framework to classify whatever is in front of the camera.

## Captest

Tests to verify you can capture video from a connected webcam.

## Capwindow

Capture video from a connected webcam and display the video in a Window.

## Counter

Capture video from a pre-recorded file, and then count the number of detected objects that cross a user-definable vertical or horizontal line.

## Faceblur

Captures video from a connected camera, then uses the CascadeClassifier to detect faces, blurs them using a Gaussian blur, then displays the blurred video in a window.

## Facedetect

Captures video from a connected camera, then uses the CascadeClassifier to detect faces, and draw a rectangle around each of them, before displaying them within a Window

## MJPEG-Streamer

Opens a video capture device, then streams MJPEG from it that you can view in any browser.

## Motion-detect

Opens a video capture device, then processes it looking for motion, human or otherwise.

## Saveimage

Capture a single frame from a connected webcam, then save it to an image file on disk.

## Savevideo

Capture video from a connected camera, and save 100 frames worth to a video file on disk.

## Showimage

Open an image file from disk, then display it in a window.

## TF Classifier

Capture video from a connected webcam, then use the Tensorflow machine learning framework to classify whatever is in front of the camera.

## Version

Displays the current version of OpenCV that is being used by GoCV.
